Attribute VB_Name = "Album"
Option Explicit

'--- DECLARE TWAIN SCANNER DLL
Declare Function TWAIN_AcquireToFilename Lib "EZTW32.DLL" (ByVal hwndApp%, ByVal bmpFileName$) As Integer
Declare Function TWAIN_SelectImageSource Lib "EZTW32.DLL" (ByVal hwndApp&) As Long
Declare Function TWAIN_AcquireToClipboard Lib "EZTW32.DLL" (ByVal hwndApp As Long, ByVal wPixTypes As Long) As Long
Declare Function TWAIN_IsAvailable Lib "EZTW32.DLL" () As Long
Declare Function TWAIN_EasyVersion Lib "EZTW32.DLL" () As Long


'
'Browse For Folder API Call

'Shell APIs from Shell32.dll file:
'SHBrowseForFolder - Gets the Browse For Folder Dialog
Private Declare Function SHBrowseForFolder Lib "shell32" (lpbi As BrowseInfo) As Long
Private Declare Function SHGetPathFromIDList Lib "shell32" (ByVal pidList As Long, ByVal lpBuffer As String) As Long


'lstrcat API function appends a string to another - that means that some API functions
'need their string in the numeric way like this does, so its kind of converts strings
'to numbers
Private Declare Function lstrcat Lib "kernel32" Alias "lstrcatA" (ByVal lpString1 As String, ByVal lpString2 As String) As Long



'Enum for the Flags of the BrowseForFolder API function
Enum BrowseForFolderFlags
    BIF_RETURNONLYFSDIRS = &H1
    BIF_DONTGOBELOWDOMAIN = &H2
    BIF_STATUSTEXT = &H4
    BIF_BROWSEFORCOMPUTER = &H1000
    BIF_BROWSEFORPRINTER = &H2000
    BIF_BROWSEINCLUDEFILES = &H4000
    BIF_EDITBOX = &H10
    BIF_RETURNFSANCESTORS = &H8
End Enum

'BrowseInfo is a type used with the SHBrowseForFolder API call
Private Type BrowseInfo
     hwndOwner As Long
     pIDLRoot As Long
     pszDisplayName As Long
     lpszTitle As Long
     ulFlags As Long
     lpfnCallback As Long
     lparam As Long
     iImage As Long
End Type


Public Db As Database
Public Rs As Recordset
Public Path1 As String
Public LenDb As Long
Public PicName As String
Public Pic As String
Public Slide As Boolean
Public NameOf As String
Public InfoOf As String
Public TemDir As String
Public TempTime As Double
Public exitPause As Boolean
Public OutOfIt As Boolean
Public MakeNew As Boolean
Public ScanImage As Boolean
Public PicPathName As String
'
'
'
'

Public Function LoadList1()
FrmMain.List1.Clear

      Dim i As Integer
       
       'Just Incase User deleted the Last
       'record from the DataBase
       On Error Resume Next
       Rs.MoveFirst
       If Rs.EOF Then Exit Function
       For i = 1 To Rs.RecordCount
       FrmMain.List1.AddItem Rs.Fields(0)
       Rs.MoveNext
       Next i
 

End Function

Public Function BrowseForFolder(hWnd As Long, Optional Title As String, Optional Flags As BrowseForFolderFlags) As String

    'Variables for use:
     Dim iNull As Integer
     Dim IDList As Long
     Dim result As Long
     Dim Path As String
     Dim bi As BrowseInfo
     Dim hwndOwner As Long
     
     If Flags = 0 Then Flags = BIF_RETURNONLYFSDIRS
     
    'Type Settings
     With bi
        .hwndOwner = hwndOwner
        .lpszTitle = lstrcat(Title, "")
        .ulFlags = Flags
     End With

    'Execute the BrowseForFolder shell API and display the dialog
     IDList = SHBrowseForFolder(bi)
     
    'Get the info out of the dialog
     If IDList Then
        Path = String$(300, 0)
        result = SHGetPathFromIDList(IDList, Path)
        iNull = InStr(Path, vbNullChar)
        If iNull Then Path = Left$(Path, iNull - 1)
     End If

    'If Cancel button was clicked, error occured or My Computer was selected then Path = ""
     BrowseForFolder = Path
End Function

Public Function OpenDb()
     'Open the DataBase
      Set Db = OpenDatabase(Path1 & "Photo.mdb")
      'Open the RecordSet
      Set Rs = Db.OpenRecordset("Pics")
End Function

Public Function CloseDb()
'Close the DataBase
On Error Resume Next
Rs.Close: Set Rs = Nothing: Db.Close: Set Db = Nothing

End Function


Public Function CreateDb()

If MakeNew = True Then GoTo 50

Dim msg, Style, Title, Response
msg = "WARNNING !!! This will Over Write Your DataBase you are Now Using" & vbCrLf & _
      "YOU NEED TO BACKUP THE DATABASE BEFORE MAKING A NEW ON" & vbCrLf & _
      "Do You Want to Continue ?"
Style = vbYesNo + vbCritical + vbDefaultButton2
Title = "Create New DataBase"
Response = MsgBox(msg, Style, Title)
If Response = vbYes Then
GoTo 50
Else
Exit Function
End If


50
CloseDb

Dim NewDB As Database
Dim NewTable As TableDef
Dim DBName As String

        'Name of New DataBase
        DBName = Path1 + "Photo.mdb"
  
        'If Old DataBase Exist then Delete It
        If Dir(DBName) <> "" Then
        Close
            Kill DBName
        End If
    

        'Create the New DataBase
        Set NewDB = CreateDatabase(DBName, dbLangGeneral)
        'Create a New Table
        Set NewTable = NewDB.CreateTableDef("Pics")
                
'Put the Fields in the New Table
    
    With NewTable
        .Fields.Append .CreateField("Name", dbText)
        .Fields.Append .CreateField("Pic", dbLongBinary)
        .Fields.Append .CreateField("Info", dbMemo)
    End With
        
        NewDB.TableDefs.Append NewTable

On Error Resume Next
 'Close the New DataBase
 NewDB.Close
 
 

If MakeNew = True Then GoTo 52

'Let the User the New DataBase has been Created
MsgBox "A New Photo DataBase has been Created", , "Create DataBase"

52
MakeNew = False
'Close the RecordSet
Rs.Close
'Close the DataBase
Db.Close
 
 OpenDb
 
 LoadList1
 
End Function


Public Function SaveResItemToDisk(ByVal iResourceNum As Integer, ByVal sResourceType As String, ByVal sDestFileName As String) As Long

    'Example Call:
    ' iRetVal = SaveResItemToDisk(101, "CUSTOM", "C:\myImage.gif")

    Dim bytResourceData()   As Byte
    Dim iFileNumOut         As Integer

    On Error GoTo SaveResItemToDisk_err

    'Retrieve the resource contents (data) into a byte array
    bytResourceData = LoadResData(iResourceNum, sResourceType)

    'Get Free File Handle
    iFileNumOut = FreeFile

    'Open the output file
    Open sDestFileName For Binary Access Write As #iFileNumOut

        'Write the resource to the file
        Put #iFileNumOut, , bytResourceData

    'Close the file
    Close #iFileNumOut

    'Return 0 for success
    SaveResItemToDisk = 0

    Exit Function
SaveResItemToDisk_err:
    'Return error number
    SaveResItemToDisk = Err.Number
End Function

Private Sub SaveIt()
 '***********************************************
  'This is where I add the First Record to the New DataBase
  'The User can Delete it Later If Not Wanted
  
  OpenDb
  
  Rs.AddNew
'Add the Info to Each Field
Dim iRetVal As Long
'Here I have a Photo saved to the Resource File
'I will copy it to Disk so that I can put it in The Record
iRetVal = SaveResItemToDisk(101, "PIC", TemDir & "\USMC.jpg")

Rs.Fields(0) = "USMC.jpg"
'Put The FileName in the Name Field
       
               '*************Start of Copy File (image) To DataBase**********************************
                   'set up the Virable to hold the File to be
                   'put in the Data Base
                    Dim Img() As Byte, i As Long
                    Close #1
                   'Open the File we got when we Choose the Image
                    Open TemDir & "\USMC.jpg" For Binary As 1
                    ReDim Img(LOF(1))
                    'get the File and put it in the Virable
                    Do While Not EOF(1)
                    Get #1, , Img
                    i = i + 1
                    Loop
                    Close #1
                    'put the Virable into the Data Base
                    'we update Data Base in the Calling sub
                    Rs.Fields(1) = Img
                    Kill TemDir & "\USMC.jpg"

'Now add Some Info about the Image
Dim ms As String
ms = "USMC.jpg is a Picture I had laying around" & vbCrLf
ms = ms & "and just put it here to have something" & vbCrLf
ms = ms & "to add to the DataBase. You can Delete this Item"

Rs.Fields(2) = ms
'UpDate the DataBase
Rs.Update

End Sub
